﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DifferentiableFunction;


//This is example code in Ch 2.7 
namespace Example_CreatingRuntimeFunction
{
    class Program
    {
        static void Main(string[] args)
        {
            Function.newContext();
            Variable a = new Variable("a"), b = new Variable("b");
            Function f = new Function(a * b, Function.sin(b));
            Function g = Function.D(f, b);
            Function e = Function.derivative(g);
            e.lhsName = "e";
            e.print();

            Function.printCompilerSource = true;
            RuntimeFunction erun = e.compile();

            double[] result = new double[2], vars = { 1, Math.PI };
            erun.eval(result, vars);
            Console.WriteLine("e[0]:" + result[0] + " e[1]:" + result[1]);
            Console.Read();
        }
    }
}
