﻿public static Function wigglyTube(Function thetaV1,Function thetaV2,double tubeRadius,double slope,double wiggleHeight) {
   const double numWiggles = 12;
   const double twist = 15;
   const double r = 1;

   Function sinTheta1 = Function.sin(thetaV1), cosTheta1 = Function.cos(thetaV1);
   Function sinTheta2 = Function.sin(thetaV2), cosTheta2 = Function.cos(thetaV2);
   Function cosNumWiggles = Function.cos(thetaV1*numWiggles + thetaV2*twist)*wiggleHeight;
   Function helix = new Function((r+cosTheta1*tubeRadius)*cosTheta2, slope*thetaV2+sinTheta1*tubeRadius,-(r+cosTheta1*tubeRadius)*sinTheta2);
   Function normal = surfaceNormal(helix,thetaV2,thetaV1);
   Function temp = cosNumWiggles*wiggleHeight;
   //temp.print();
   Function scaledNormal = normal*temp;
   Function wiggleSurf = helix + scaledNormal;
   Function surf = new Function(wiggleSurf[0], wiggleSurf[1], wiggleSurf[2]);
   return surf;
}
