//Written by Leonid Velikovich and Benjamin Hernandez Arreguin

//+-----------------------------------------------------------------------------
//
//  Class HighPerformanceTimer.  Used for taking performance metrics.
//
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Text;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace ParametricModelEditor
{
    static class HighPerformanceTimer
    {
        [DllImport("Kernel32.dll")]
        private static extern bool QueryPerformanceCounter(
            out long lpPerformanceCount);

        [DllImport("Kernel32.dll")]
        private static extern bool QueryPerformanceFrequency(
            out long lpFrequency);


        static HighPerformanceTimer()
        {
            if (QueryPerformanceFrequency(out _frequency) == false)
            {
                throw new Win32Exception();
            }
        }

        public static double GetTimeInSeconds()
        {
            long currentTime;
            QueryPerformanceCounter(out currentTime);

            return (double)currentTime / (double)_frequency;
        }


        private static long _frequency;
    }
}
