//Written by Leonid Velikovich and Benjamin Hernandez Arreguin

//+-----------------------------------------------------------------------------
//
//  Class ParametricCurve2D.  Base class for a curve that maps a 1D value in
//  the range [0..1] to a curve in 2D space.
//
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;
using System.Text;
using System.Windows.Forms;
using Microsoft.Xna.Framework;

namespace ParametricModelEditor
{
    public abstract class ParametricCurve2D
    {
        // Evaluates a parametric curve over the interval [0, 1]
        public abstract void Evaluate(float t, out Vector2 position,
                                               out Vector2 tangent,
                                               out Vector2 acceleration);
        
        public virtual float[] GetSingularPoints() { return null; }

        public virtual Vector2[] GetControlPoints() { return null; }

        public virtual ParametricCurve2D GetSerialization() { return this; }
    }
}
