//Written by Leonid Velikovich and Benjamin Hernandez Arreguin

//+-----------------------------------------------------------------------------
//
// VertexPosition2D class.  Supplements Xna vertex element types.  Has only
// a 2D vector, which is the domain-space coordinate for parametric surfaces.
//
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Text;
using System.Windows.Forms;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;


namespace ParametricModelEditor
{
    public struct VertexPosition2D
    {
        public Vector2 Position;

        public VertexPosition2D(Vector2 position)
        {
            Position = position;
        }

        public static VertexElement[] Elements =
            {
                new VertexElement(0, 0, VertexElementFormat.Vector2,
                                        VertexElementMethod.Default,
                                        VertexElementUsage.Position, 0),
            };
        public static int SizeInBytes = sizeof(float) * 2;
    }
}
