//Written by Leonid Velikovich and Benjamin Hernandez Arreguin

//+-----------------------------------------------------------------------------
//
// VertexPositionNormal class.  Supplements Xna vertex element types.
// Used as the output type when running a parametric effect in software.
//
//------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Text;
using System.Windows.Forms;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;


namespace ParametricModelEditor
{
    public struct VertexPositionNormal
    {
        public Vector3 Position;
        public Vector3 Normal;

        public VertexPositionNormal(Vector3 position, Vector3 normal)
        {
            Position = position;
            Normal   = normal;
        }

        public static VertexElement[] Elements =
            {
                new VertexElement(0, 0, VertexElementFormat.Vector3,
                                        VertexElementMethod.Default,
                                        VertexElementUsage.Position, 0),
                new VertexElement(0, sizeof(float)*3, VertexElementFormat.Vector3,
                                                      VertexElementMethod.Default,
                                                      VertexElementUsage.Normal, 0),
            };
        public static int SizeInBytes = sizeof(float) * 6;
    }
}
