#region Using Statements
using System;
using System.IO;

using System.Collections.Generic;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using matrix;
using utilities;
using DifferentiableFunction;
using WinFormsGraphicsDevice.Geometries;
#endregion


namespace WinFormsGraphicsDevice
{

    /// <summary>
    /// This is a parser class for buliding a set of RigidBodySystems specified in an input file.
    /// </summary>
    public class RigidBodySystemsBuilder
    {
        GraphicsDeviceManager graphics;
        ContentManager content;
        List<Texture2D> textures;
        List<Prop> props;
        Ground ground;

        Dictionary<string, double> constTable = new Dictionary<string, double>(); //contant lookup table

        public RigidBodySystemsBuilder(GraphicsDeviceManager graphics, ContentManager content, List<Texture2D> textures, Ground ground, List<Prop> props)
        {
            this.graphics = graphics;
            this.content = content;
            this.textures = textures;
            this.props = props;
            this.ground = ground;
        }

           

        /*
        void ReadGround(StreamReader sr, Ground ground)
        {
            string[] words;
            while ((words = ReadLine(sr)) != null)
            {
                switch (words[0])
                {
                    case "END_GROUND":
                        return;
                    case "CENTER":
                        ground.center.X = ParseToFloat(words[1]);
                        ground.center.Y = ParseToFloat(words[2]);
                        ground.center.Z = ParseToFloat(words[3]);
                        break;
                    case "WIDTH":
                        ground.width = ParseToFloat(words[1]);
                        break;
                    case "DEPTH":
                        ground.depth = ParseToFloat(words[1]);
                        break;
                    case "TEXTURE":
                        ground.texture = FindTexture(words[1]);
                        break;
                    case "NUM_WRAPS_U":
                        ground.numWrapsU = ParseToInt(words[1]);
                        break;
                    case "NUM_WRAPS_V":
                        ground.numWrapsV = ParseToInt(words[1]);
                        break;
                    case "REFLECTIVITY":
                        ground.reflectivity = ParseToFloat(words[1]);
                        break;
                    default:
                        throw new Exception("Undefined keyword");
                }
            }
        }
         * */

        /*
        void ReadPropModel(StreamReader sr, RigidBodySystem system)
        {
            string[] words;
            Prop prop = new Prop();
            while ((words = ReadLine(sr)) != null)
            {
                switch (words[0])
                {
                    case "END_PROP_MODEL":
                        props.Add(prop);
                        return;
                    case "FILE":
                        string filepath = words[1].Substring(1, words[1].Length - 2);
                        prop.model = content.Load<Model>(filepath);
                        //register texture if exists
                        foreach (ModelMesh mesh in prop.model.Meshes)
                        {
                            foreach (ModelMeshPart part in mesh.MeshParts)
                            {
                                Texture2D t = (part.Effect as BasicEffect).Texture;
                                if (t != null)
                                {
                                    mesh.Tag = (object)t; //embed texture info into mesh
                                }
                            }
                        }
                        break;
                    case "PARENT":
                        prop.parent = system.FindLink(words[1]);
                        break;
                    case "LOCAL_MATRIX":
                        prop.mat = ReadPropMatrix(sr, system);
                        break;
                    case "LIGHT_INTENSITY":
                        prop.lightIntensity = ParseToFloat(words[1]);
                        break;
                    case "REFLECTIVITY":
                        prop.reflectivity = ParseToFloat(words[1]);
                        break;
                    default:
                        throw new Exception("Undefined keyword");
                }
            }
        }
         * */

 
/*
        void ReadShape(StreamReader sr, Link link)
        {
            int numU = 1, numV = 1;
            string textureName = "";
            string type = "";
            //Texture2D texture;
            double[] args = new double[0];
            string[] words;
            bool createMesh = true;
            while ((words = ReadLine(sr)) != null)
            {
                switch (words[0])
                {
                    case "END_SHAPE":
                        link.CreateGeometry(graphics.GraphicsDevice, type, numU, numV, FindTexture(textureName), createMesh, args);                            
                        return;
                    case "NUM_U":
                        numU = ParseToInt(words[1]);
                        break;
                    case "NUM_V":
                        numV = ParseToInt(words[1]);
                        break;
                    case "TEXTURE":
                        textureName = string.Copy(words[1]);
                        break;
                    case "REFLECTIVITY":
                        link.reflectivity = ParseToFloat(words[1]);
                        break;
                    case "VISIBILITY":
                        if (words[1] == "INVISIBLE") createMesh = false;
                        break;
                    case "TYPE":
                        type = words[1];// string.Copy(words[1]);
                        args = new double[words.Length - 2];
                        for (int i = 2; i < words.Length; i++)
                        {
                            args[i - 2] = ParseToDouble(words[i]);
                        }
                        break;
                    default:
                        throw new Exception("Undefined keyword");
                }
            }
        }
 * */

    }

}