﻿
using System;
using System.Diagnostics;
using System.IO;
using System.Windows.Forms;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using matrix;
using utilities;
using DifferentiableFunction;
using Dynamics;


namespace WinFormsGraphicsDevice
{
    //class RigidBodySystem;
    public class test : iRigidBodySystemFunctions
    {
        /*
        public test ()
        {
        }
	    */
        public RigidBodySystem build(GraphicsDevice device, Texture2D[] textureMaps)
        {
            Function.newContext();
            List<RigidBody> alljoints = new List<RigidBody>();
            Variable t = new Variable("t");
            Graph<JointNode> g = null;
            Function[,] centerOfMass = { { 0 }, { 0 }, { 0 }, { 1 } }; //point so need 1 in 4th position


            UnspecifiedFunction q0 = UnspecifiedFunction.functionOf("q0", t);
            Variable massRigidBody0 = new Variable("m0");
            Variable posX0 = new Variable("posX0");
            Variable posY0 = new Variable("posY0");
            Variable posZ0 = new Variable("posZ0");

            
            List<double> pos = new List<double>();
            List<double> mass = new List<double>();
            pos.Add(0.0);
            pos.Add(4.0);
            pos.Add(0.0);
            mass.Add(1.0);
            Function[,] A0 = { { 1, 0, 0, posX0 }, { 0, 1, 0, posY0 }, { 0, 0, 1, posZ0 }, { 0, 0, 0, 1 } };
            A0 = VM.mult(A0, VM.rotX(Math.PI * 0.00 / 180.0, 0, 0, 0));
            A0 = VM.mult(A0, VM.rotY(Math.PI * 0.00 / 180.0, 0, 0, 0));
            A0 = VM.mult(A0, VM.rotZ(Math.PI * 0.00 / 180.0, 0, 0, 0));

            Function[,] rb0 = null;
            rb0 = VM.rotX(q0, 0, 0, 0);
            //A0 = VM.mult(A0, rb0);
            
            Function[,] I = inertiaMatrixSphere(massRigidBody0, 0.50);
            Geometries.Sphere sphere = new Geometries.Sphere(0.5);
            RigidBody rigidBody0 = new RigidBody(A0, new Function[] { q0 }, frictionForce(t, q0), centerOfMass, I, massRigidBody0, "rootBody", t);
            rigidBody0.CreateGeometry(device, sphere, textureMaps[10 % 4]);
            rigidBody0.geometry = sphere;
            rigidBody0.force = new Function[,] { { 9.00 }, { -9.80 * 1.00 }, { 2.00 }, { 0 } };
            rigidBody0.torque = new Function[,] { { 0.00 }, { 0.00 }, { 0.00 }, { 0 } };

            alljoints.Add(rigidBody0);

            
            Function[,] centerOfMass1 = { { 0 }, { 0 }, { 0 }, { 1 } };
            Function[,] rb1 = null;
            Variable massRigidBody1 = new Variable("m1");
            Variable posX1 = new Variable("posX1");
            Variable posY1 = new Variable("posY1");
            Variable posZ1 = new Variable("posZ1");
            pos.Add(1.0);
            pos.Add(0.0);
            pos.Add(0.0);
            mass.Add(1.0);
            Function[,] A1 = { { 1, 0, 0, posX1 }, { 0, 1, 0, posY1}, { 0, 0, 1, posZ1}, { 0, 0, 0, 1 } };
            UnspecifiedFunction q1 = UnspecifiedFunction.functionOf("q1", t);
            A1 = VM.mult(A1, VM.rotX(Math.PI * 0.00 / 180.0, 0, 0, 0));
            A1 = VM.mult(A1, VM.rotY(Math.PI * 0.00 / 180.0, 0, 0, 0));
            A1 = VM.mult(A1, VM.rotZ(Math.PI * 0.00 / 180.0, 0, 0, 0));
            Function[,] I1 = inertiaMatrixSphere(massRigidBody1, 0.50);
            Geometries.Sphere sphere1 = new Geometries.Sphere(0.50);
            rb1 = VM.rotZ(q1, 0, 0, 0); 
            //A1 = VM.mult(A1, VM.rotZ(q1, 0, 0, 0));
            RigidBody rigidBody1 = new RigidBody(A1, new Function[] { q1 }, frictionForce(t, q1), centerOfMass1, I1, massRigidBody1, "Body1", t);
            rigidBody1.CreateGeometry(device, sphere1, textureMaps[1]);
            rigidBody1.force = new Function[,] { { 5.00 }, { -9.80 * 1.00 }, { 3.00 }, { 0 } };
            rigidBody1.geometry = sphere1;
            rigidBody1.torque = new Function[,] { { 0.00 }, { 0.00 }, { 0.00 }, { 0 } };

            alljoints.Add(rigidBody1);
            rigidBody0.c(rigidBody1);

            
            Function[,] centerOfMass2 = { { 0 }, { 0 }, { 0 }, { 1 } };
            Function[,] rb2 = null;
            Variable massRigidBody2 = new Variable("m2");
            Variable posX2 = new Variable("posX2");
            Variable posY2 = new Variable("posY2");
            Variable posZ2 = new Variable("posZ2");
            pos.Add(3.0);
            pos.Add(0.0);
            pos.Add(1.0);
            mass.Add(1.0);
            Function[,] A2 = { { 1, 0, 0, posX2 }, { 0, 1, 0, posY2 }, { 0, 0, 1, posZ2}, { 0, 0, 0, 1 } };
            UnspecifiedFunction q2 = UnspecifiedFunction.functionOf("q2", t);
            A2 = VM.mult(A2, VM.rotX(Math.PI * 0.00 / 180.0, 0, 0, 0));
            A2 = VM.mult(A2, VM.rotY(Math.PI * 0.00 / 180.0, 0, 0, 0));
            A2 = VM.mult(A2, VM.rotZ(Math.PI * 0.00 / 180.0, 0, 0, 0));
            Function[,] I2 = inertiaMatrixTorus(massRigidBody2, 2.00, 0.10);
            Geometries.Torus torus2 = new Geometries.Torus(2.00, 0.10);
            rb2 = VM.rotZ(q2, 0, 0, 0);
            
            RigidBody rigidBody2 = new RigidBody(A2, new Function[] { q2 }, frictionForce(t, q2), centerOfMass2, I2, massRigidBody2, "Body2", t);
            rigidBody2.CreateGeometry(device, torus2, textureMaps[2]);
            rigidBody2.force = new Function[,] { { 1.00 }, { -9.80 * 1.00 }, { 3.00 }, { 0 } };
            rigidBody2.geometry = torus2;
            rigidBody2.torque = new Function[,] { { 9.00 }, { 0.00 }, { 0.00 }, { 0 } };
            alljoints.Add(rigidBody2);
            rigidBody0.c(rigidBody2);

            //Function mass = new Function();
            //mass = 10.0;
            
            Function[,] centerOfMass3 = { { 0 }, { 0 }, { 0 }, { 1 } };
            Function[,] rb3 = null;
            Variable massRigidBody3 = new Variable("m3");
            Variable posX3 = new Variable("posX3");
            Variable posY3 = new Variable("posY3");
            Variable posZ3 = new Variable("posZ3");
            pos.Add(0.0);
            pos.Add(0.0);
            pos.Add(0.0);
            mass.Add(1.0);
            Function[,] A3 = { { 1, 0, 0, posX3 }, { 0, 1, 0, posY3}, { 0, 0, 1, posZ3}, { 0, 0, 0, 1 } };
            UnspecifiedFunction q3 = UnspecifiedFunction.functionOf("q3", t);
            A3 = VM.mult(A3, VM.rotX(Math.PI * 0.00 / 180.0, 0, 0, 0));
            A3 = VM.mult(A3, VM.rotY(Math.PI * 0.00 / 180.0, 0, 0, 0));
            A3 = VM.mult(A3, VM.rotZ(Math.PI * 0.00 / 180.0, 0, 0, 0));
            Function[,] I3 = inertiaMatrixSphere(massRigidBody3, 0.40);
            Geometries.Sphere sphere3 = new Geometries.Sphere(0.40);
            UnspecifiedFunction q4 = UnspecifiedFunction.functionOf("q4", t);
            rb3 = rigidBody2.geometry.SurfaceTangentFrame(q3, q4);
            
            RigidBody rigidBody3 = new RigidBody(A3, new Function[] { q3, q4 }, frictionForce(t, q3, q4), centerOfMass3, I3, massRigidBody3, "Body3", t);
            rigidBody3.CreateGeometry(device, sphere3, textureMaps[1]);
            rigidBody3.force = new Function[,] { { 0.50 * rb3[0, 0] }, { -9.80 * 1.00 }, { 0.00 * rb3[2, 0] }, { 0 } };
            rigidBody3.geometry = sphere3;
            rigidBody3.torque = new Function[,] { { 0.00 }, { 0.00 }, { 0.00 }, { 0 } };
            alljoints.Add(rigidBody3);
            rigidBody2.c(rigidBody3);
            /*
            g = new Graph<JointNode>(rigidBody0, alljoints.ToArray());
            Function.printCompilerSource = true;
            RigidBodySystem RBSTemp = new RigidBodySystem(g, t, device, mass.ToArray(), pos.ToArray());
            Function.printCompilerSource = false;
            RBSTemp.initialize();
            return RBSTemp;
             * */
            return null;
        }


        public void populateTreeView(TreeView rigidBodyHierarchy, string RBSFileName)
        {
            TreeNode root = new TreeNode(RBSFileName);
            root.ImageIndex = 0;
            root.Name = RBSFileName;
            rigidBodyHierarchy.Nodes.Insert(0, root);
            cRigidBodyUI body0 = new cRigidBodyUI();
            body0.position.X = 0;
            body0.position.Y = 0;
            body0.position.Z = 0;
            body0.orientation.X = 0;
            body0.orientation.Y = 0;
            body0.orientation.Z = 0;
            body0.Sphere.Radius = 0.5;
            body0.Sphere.Use_sphere = true;
            body0.Cylinder.Final_Angle = 360;
            body0.Cylinder.Height = 2;
            body0.Cylinder.Initial_Angle = 0;
            body0.Cylinder.Radius = 0.3;
            body0.Cylinder.Use_Cylinder = false;
            body0.Torus.Inner_Radius = 0.2;
            body0.Torus.Outer_Radius = 0.8;
            body0.Torus.Use_Torus = false;
            body0.Mass = 1;
            body0.Forces.X = 0;
            body0.Forces.Y = -9.8;
            body0.Forces.Z = 0;
            body0.Torque.X = 0;
            body0.Torque.Y = 0;
            body0.Torque.Z = 0;
            body0.RotXAxis = true;
            body0.RotYAxis = false;
            body0.RotZAxis = false;
            body0.TransXaxis = false;
            body0.TransYaxis = false;
            body0.TransZaxis = false;
            body0.Surface = false;
            body0.Name = "rootBody";
            body0.Text = "rootBody";
            body0.ImageIndex = 1;

            cRigidBodyUI body1 = new cRigidBodyUI();
            body1.position.X = 1;
            body1.position.Y = 0;
            body1.position.Z = 0;
            body1.orientation.X = 0;
            body1.orientation.Y = 0;
            body1.orientation.Z = 0;
            body1.Sphere.Radius = 0.5;
            body1.Sphere.Use_sphere = true;
            body1.Cylinder.Final_Angle = 360;
            body1.Cylinder.Height = 2;
            body1.Cylinder.Initial_Angle = 0;
            body1.Cylinder.Radius = 0.3;
            body1.Cylinder.Use_Cylinder = false;
            body1.Torus.Inner_Radius = 0.2;
            body1.Torus.Outer_Radius = 0.8;
            body1.Torus.Use_Torus = false;
            body1.Mass = 1;
            body1.Forces.X = 0;
            body1.Forces.Y = -9.8;
            body1.Forces.Z = 0;
            body1.Torque.X = 0;
            body1.Torque.Y = 0;
            body1.Torque.Z = 0;
            body1.RotXAxis = false;
            body1.RotYAxis = false;
            body1.RotZAxis = false;
            body1.TransXaxis= false;
            body1.TransYaxis = false;
            body1.TransZaxis = false;
            body1.Surface = false;
            body1.Name = "Body1";
            body1.Text = "Body1";
            body1.ImageIndex = 1;
            body0.Nodes.Insert(body0.Nodes.Count + 1, body1);

            cRigidBodyUI body2 = new cRigidBodyUI();
            body2.position.X = 3;
            body2.position.Y = 0;
            body2.position.Z = 0;
            body2.orientation.X = 0;
            body2.orientation.Y = 0;
            body2.orientation.Z = 0;
            body2.Sphere.Radius = 0.5;
            body2.Sphere.Use_sphere = false;
            body2.Cylinder.Final_Angle = 360;
            body2.Cylinder.Height = 2;
            body2.Cylinder.Initial_Angle = 0;
            body2.Cylinder.Radius = 0.3;
            body2.Cylinder.Use_Cylinder = false;
            body2.Torus.Inner_Radius = 0.1;
            body2.Torus.Outer_Radius = 2;
            body2.Torus.Use_Torus = true;
            body2.Mass = 1;
            body2.Forces.X = 0;
            body2.Forces.Y = -9.8;
            body2.Forces.Z = 0;
            body2.Torque.X = 9;
            body2.Torque.Y = 0;
            body2.Torque.Z = 0;
            body2.RotXAxis = false;
            body2.RotYAxis = false;
            body2.RotZAxis = false;
            body2.TransXaxis = false;
            body2.TransYaxis = false;
            body2.TransZaxis = false;
            body2.Surface = false;
            body2.Name = "Body2";
            body2.Text = "Body2";
            body2.ImageIndex = 1;
            body0.Nodes.Insert(body0.Nodes.Count + 1, body2);

            cRigidBodyUI body3 = new cRigidBodyUI();
            body3.position.X = 0;
            body3.position.Y = 0;
            body3.position.Z = 0;
            body3.orientation.X = 0;
            body3.orientation.Y = 0;
            body3.orientation.Z = 0;
            body3.Sphere.Radius = 0.4;
            body3.Sphere.Use_sphere = true;
            body3.Cylinder.Final_Angle = 360;
            body3.Cylinder.Height = 2;
            body3.Cylinder.Initial_Angle = 0;
            body3.Cylinder.Radius = 0.3;
            body3.Cylinder.Use_Cylinder = false;
            body3.Torus.Inner_Radius = 0.2;
            body3.Torus.Outer_Radius = 0.8;
            body3.Torus.Use_Torus = false;
            body3.Mass = 1;
            body3.Forces.X = 0.5;
            body3.Forces.Y = -9.8;
            body3.Forces.Z = 0;
            body3.Torque.X = 0;
            body3.Torque.Y = 0;
            body3.Torque.Z = 0;
            body3.RotXAxis = false;
            body3.RotYAxis = false;
            body3.RotZAxis = false;
            body3.TransXaxis = false;
            body3.TransYaxis = false;
            body3.TransZaxis = false;
            body3.Surface = true;
            body3.Name = "Body3";
            body3.Text = "Body3";
            body3.ImageIndex = 1;
            body2.Nodes.Insert(body2.Nodes.Count + 1, body3);

            rigidBodyHierarchy.Nodes[0].Nodes.Insert(rigidBodyHierarchy.Nodes[0].Nodes.Count, body0);
        }

        public Function[] frictionForce(Variable t, params Function[] genCoords)
        {
            Function[] result = new Function[genCoords.Length];

            //for (int i = 0; i < genCoords.Length; i++) { result[i] = (- Math.PI/2.0 - genCoords[i] ) - .2 * Function.D(genCoords[i], t); } //this works only for one cylinder
            for (int i = 0; i < genCoords.Length; i++) { result[i] = -2 * Function.D(genCoords[i], t); }
            return result;
        }

        public Function[,] inertiaMatrixCylinder(double mass, double radius, double height)
        {
            // moment of inertia:
            return new Function[,]{{1/12.0*mass*(3*(radius*radius) + (height*height)), 0 ,0 ,0},
                         {0, .5*mass*(radius*radius), 0 ,0},
                         {0, 0, 1/12.0*mass*(3*(radius*radius) + (height*height)), 0},
                         {0,0,0,0}};
        }

        public Function[,] inertiaMatrixTorus(double mass, double largeRadius, double smallRadius)
        {
            return new Function[,]{{1/8.0*mass*(4*largeRadius*largeRadius + 5*smallRadius*smallRadius), 0 ,0 ,0},
                         {0, .25*mass*(4*largeRadius*largeRadius + 3*smallRadius*smallRadius), 0 ,0},
                         {0, 0, 1/8.0*mass*(4*largeRadius*largeRadius + 5*smallRadius*smallRadius), 0},
                         {0,0,0,0}};
        }

        public Function[,] inertiaMatrixTorus(Variable mass, double largeRadius, double smallRadius)
        {
            return new Function[,]{{1/8.0*mass*(4*largeRadius*largeRadius + 5*smallRadius*smallRadius), 0 ,0 ,0},
                         {0, .25*mass*(4*largeRadius*largeRadius + 3*smallRadius*smallRadius), 0 ,0},
                         {0, 0, 1/8.0*mass*(4*largeRadius*largeRadius + 5*smallRadius*smallRadius), 0},
                         {0,0,0,0}};
        }

        public Function[,] inertiaMatrixSphere(double mass, double radius)
        {
            return new Function[,]{ {0.4*mass*radius*radius, 0 ,0 ,0},
                                    {0, 0.4*mass*radius*radius, 0 ,0},
                                    {0, 0, 0.4*mass*radius*radius, 0},
                                    {0,0,0,0}};
        }

        public Function[,] inertiaMatrixSphere(Variable mass, double radius)
        {
            return new Function[,]{ {0.4*mass*radius*radius, 0 ,0 ,0},
                                    {0, 0.4*mass*radius*radius, 0 ,0},
                                    {0, 0, 0.4*mass*radius*radius, 0},
                                    {0,0,0,0}};
        }
    }
}
