﻿
using System;
using System.Diagnostics;
using System.IO;
using System.Windows.Forms;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using matrix;
using utilities;
using DifferentiableFunction;
using Dynamics;


namespace WinFormsGraphicsDevice {
    //class RigidBodySystem;
	public class rbsExample4 : iRigidBodySystemFunctions 
    {
        /*
        public as ()
        {
        }
	    */
        public RigidBodySystem build(GraphicsDevice device, Texture2D[] textureMaps)
        {
        Function.newContext();
        List<RigidBody> alljoints = new List<RigidBody>();
		Variable t = new Variable("t");
		Graph<JointNode> g = null;
		Function[,] centerOfMass = { { 0 }, { 0 }, { 0 }, { 1 } }; //point so need 1 in 4th position
		
        
		List<double> pos = new List<double>();
		List<double> mass = new List<double>();
		List<double> angles = new List<double>();
		List<double> force = new List<double>();
		List<double> torque = new List<double>();
		UnspecifiedFunction q0 = UnspecifiedFunction.functionOf( "q0", t);
		Variable m0= new Variable("m0");
		Variable posX0 = new Variable("posX0");
		Variable posY0 = new Variable("posY0");
		Variable posZ0 = new Variable("posZ0");
		Variable angleX0 = new Variable("angleX0");
		Variable angleY0 = new Variable("angleY0");
		Variable angleZ0 = new Variable("angleZ0");
		Variable forceX0 = new Variable("forceX0");
		Variable forceY0 = new Variable("forceY0");
		Variable forceZ0 = new Variable("forceZ0");
		Variable torqueX0 = new Variable("torqueX0");
		Variable torqueY0 = new Variable("torqueY0");
		Variable torqueZ0 = new Variable("torqueZ0");
		pos.Add(0);
		pos.Add(5);
		pos.Add(0);
		angles.Add(0);
		angles.Add(0);
		angles.Add(0);
		mass.Add(1);
		force.Add(0);
		force.Add(-9.8);
		torque.Add(0);
		torque.Add(-9.8);
		torque.Add(0);
		Function[,] A0 = {{ 1, 0, 0, posX0}, { 0, 1, 0, posY0 }, { 0, 0, 1, posZ0}, { 0, 0, 0, 1 } };
		Function[,] rb0= null;
		A0 = VM.mult(A0, VM.rotX(angleX0, 0, 0, 0));
		A0 = VM.mult(A0, VM.rotY(angleY0, 0, 0, 0));
		A0 = VM.mult(A0, VM.rotZ(angleZ0, 0, 0, 0));
		A0 = VM.mult(A0, VM.rotX( q0, 0, 0, 0));
		Function[,] I = inertiaMatrixSphere(m0, 0.50);
		Geometries.Sphere sphere = new Geometries.Sphere(0.5);
		RigidBody rigidBody0 = new RigidBody(A0, new Function[] { q0 }, frictionForce(t, q0), centerOfMass, I, m0, "rootBody", t);
		rigidBody0.CreateGeometry(device , sphere, textureMaps[10%4]);
		rigidBody0.geometry =  sphere;
		rigidBody0.orientation = new Variable[] {angleX0, angleY0, angleZ0};
		rigidBody0.position = new Variable[] {posX0, posY0, posZ0};
		rigidBody0.force = new Function[,] { { forceX0 }, { forceY0}, { forceZ0 }, { 0 }};
		rigidBody0.torque = new Function[,] { { torqueX0 }, { torqueY0 }, { torqueZ0 }, { 0 }};
		alljoints.Add(rigidBody0);

		Function[,] centerOfMass1 = { { 0 }, { 0 }, { 0 }, { 1 } };
		Function[,] rb1 = null;
		UnspecifiedFunction q1 = UnspecifiedFunction.functionOf("q1", t);
		Variable m1 = new Variable("m1");
		Variable posX1 = new Variable("posX1");
		Variable posY1 = new Variable("posY1");
		Variable posZ1 = new Variable("posZ1");
		Variable angleX1 = new Variable("angleX1");
		Variable angleY1 = new Variable("angleY1");
		Variable angleZ1 = new Variable("angleZ1");
		Variable forceX1 = new Variable("forceX1");
		Variable forceY1 = new Variable("forceY1");
		Variable forceZ1 = new Variable("forceZ1");
		Variable torqueX1 = new Variable("torqueX1");
		Variable torqueY1 = new Variable("torqueY1");
		Variable torqueZ1 = new Variable("torqueZ1");
		pos.Add(0);
		pos.Add(0);
		pos.Add(0);
		angles.Add(0);
		angles.Add(0);
		angles.Add(0);
		mass.Add(1);
		force.Add(0);
		force.Add(-9.8);
		torque.Add(0);
		torque.Add(-9.8);
		torque.Add(0);
		Function[,] A1 = { { 1, 0, 0, posX1 }, { 0, 1, 0, posY1}, { 0, 0, 1, posZ1}, { 0, 0, 0, 1 } };
		A1 = VM.mult(A1, VM.rotX(angleX1, 0, 0, 0));
		A1 = VM.mult(A1, VM.rotY(angleY1, 0, 0, 0));
		A1 = VM.mult(A1, VM.rotZ(angleZ1, 0, 0, 0));
		Function[,] I1 = inertiaMatrixCylinder(m1, 0.10, 5.00);
		Geometries.Cylinder cylinder1 = new Geometries.Cylinder(0.00 * Math.PI / 180.0, 360.00 * Math.PI / 180.0, 0.0, 5.00, 0.10);
		A1 = VM.mult(A1, VM.rotZ(q1, 0, 0, 0));
		RigidBody rigidBody1 = new RigidBody(A1, new Function[] { q1 }, frictionForce(t, q1), centerOfMass1, I1, m1, "Body1", t);
		rigidBody1.CreateGeometry(device, cylinder1, textureMaps[1]);
		rigidBody1.force = new Function[,] { { forceX1}, { forceY1 }, { forceZ1}, { 0 } };
		rigidBody1.orientation = new Variable[] {angleX1, angleY1, angleZ1};
		rigidBody1.position = new Variable[] {posX1, posY1, posZ1};
		rigidBody1.torque = new Function[,] { { torqueX1 }, { torqueY1 }, { torqueZ1 }, { 0 }};
		rigidBody1.geometry = cylinder1;
		alljoints.Add(rigidBody1);
		rigidBody0.c(rigidBody1);

		Function[,] centerOfMass2 = { { 0 }, { 0 }, { 0 }, { 1 } };
		Function[,] rb2 = null;
		UnspecifiedFunction q2 = UnspecifiedFunction.functionOf("q2", t);
		Variable m2 = new Variable("m2");
		Variable posX2 = new Variable("posX2");
		Variable posY2 = new Variable("posY2");
		Variable posZ2 = new Variable("posZ2");
		Variable angleX2 = new Variable("angleX2");
		Variable angleY2 = new Variable("angleY2");
		Variable angleZ2 = new Variable("angleZ2");
		Variable forceX2 = new Variable("forceX2");
		Variable forceY2 = new Variable("forceY2");
		Variable forceZ2 = new Variable("forceZ2");
		Variable torqueX2 = new Variable("torqueX2");
		Variable torqueY2 = new Variable("torqueY2");
		Variable torqueZ2 = new Variable("torqueZ2");
		pos.Add(5);
		pos.Add(0);
		pos.Add(0);
		angles.Add(0);
		angles.Add(0);
		angles.Add(0);
		mass.Add(1);
		force.Add(0);
		force.Add(-9.8);
		torque.Add(0);
		torque.Add(-9.8);
		torque.Add(0);
		Function[,] A2 = { { 1, 0, 0, posX2 }, { 0, 1, 0, posY2}, { 0, 0, 1, posZ2}, { 0, 0, 0, 1 } };
		A2 = VM.mult(A2, VM.rotX(angleX2, 0, 0, 0));
		A2 = VM.mult(A2, VM.rotY(angleY2, 0, 0, 0));
		A2 = VM.mult(A2, VM.rotZ(angleZ2, 0, 0, 0));
		Function[,] I2 = inertiaMatrixSphere(m2, 0.50);
		Geometries.Sphere sphere2 = new Geometries.Sphere(0.50);
		A2 = VM.mult(A2, VM.rotZ(q2, 0, 0, 0));
		RigidBody rigidBody2 = new RigidBody(A2, new Function[] { q2 }, frictionForce(t, q2), centerOfMass2, I2, m2, "Body2", t);
		rigidBody2.CreateGeometry(device, sphere2, textureMaps[1]);
		rigidBody2.force = new Function[,] { { forceX2}, { forceY2 }, { forceZ2}, { 0 } };
		rigidBody2.orientation = new Variable[] {angleX2, angleY2, angleZ2};
		rigidBody2.position = new Variable[] {posX2, posY2, posZ2};
		rigidBody2.torque = new Function[,] { { torqueX2 }, { torqueY2 }, { torqueZ2 }, { 0 }};
		rigidBody2.geometry = sphere2;
		alljoints.Add(rigidBody2);
		rigidBody1.c(rigidBody2);

		Function[,] centerOfMass3 = { { 0 }, { 0 }, { 0 }, { 1 } };
		Function[,] rb3 = null;
		UnspecifiedFunction q3 = UnspecifiedFunction.functionOf("q3", t);
		Variable m3 = new Variable("m3");
		Variable posX3 = new Variable("posX3");
		Variable posY3 = new Variable("posY3");
		Variable posZ3 = new Variable("posZ3");
		Variable angleX3 = new Variable("angleX3");
		Variable angleY3 = new Variable("angleY3");
		Variable angleZ3 = new Variable("angleZ3");
		Variable forceX3 = new Variable("forceX3");
		Variable forceY3 = new Variable("forceY3");
		Variable forceZ3 = new Variable("forceZ3");
		Variable torqueX3 = new Variable("torqueX3");
		Variable torqueY3 = new Variable("torqueY3");
		Variable torqueZ3 = new Variable("torqueZ3");
		pos.Add(0);
		pos.Add(0);
		pos.Add(0);
		angles.Add(0);
		angles.Add(0);
		angles.Add(0);
		mass.Add(1);
		force.Add(0);
		force.Add(-9.8);
		torque.Add(0);
		torque.Add(-9.8);
		torque.Add(0);
		Function[,] A3 = { { 1, 0, 0, posX3 }, { 0, 1, 0, posY3}, { 0, 0, 1, posZ3}, { 0, 0, 0, 1 } };
		A3 = VM.mult(A3, VM.rotX(angleX3, 0, 0, 0));
		A3 = VM.mult(A3, VM.rotY(angleY3, 0, 0, 0));
		A3 = VM.mult(A3, VM.rotZ(angleZ3, 0, 0, 0));
		Function[,] I3 = inertiaMatrixCylinder(m3, 0.10, 5.00);
		Geometries.Cylinder cylinder3 = new Geometries.Cylinder(0.00 * Math.PI / 180.0, 360.00 * Math.PI / 180.0, 0.0, 5.00, 0.10);
		A3 = VM.mult(A3, VM.rotZ(q3, 0, 0, 0));
		RigidBody rigidBody3 = new RigidBody(A3, new Function[] { q3 }, frictionForce(t, q3), centerOfMass3, I3, m3, "Body3", t);
		rigidBody3.CreateGeometry(device, cylinder3, textureMaps[1]);
		rigidBody3.force = new Function[,] { { forceX3}, { forceY3 }, { forceZ3}, { 0 } };
		rigidBody3.orientation = new Variable[] {angleX3, angleY3, angleZ3};
		rigidBody3.position = new Variable[] {posX3, posY3, posZ3};
		rigidBody3.torque = new Function[,] { { torqueX3 }, { torqueY3 }, { torqueZ3 }, { 0 }};
		rigidBody3.geometry = cylinder3;
		alljoints.Add(rigidBody3);
		rigidBody0.c(rigidBody3);

		Function[,] centerOfMass4 = { { 0 }, { 0 }, { 0 }, { 1 } };
		Function[,] rb4 = null;
		UnspecifiedFunction q4 = UnspecifiedFunction.functionOf("q4", t);
		Variable m4 = new Variable("m4");
		Variable posX4 = new Variable("posX4");
		Variable posY4 = new Variable("posY4");
		Variable posZ4 = new Variable("posZ4");
		Variable angleX4 = new Variable("angleX4");
		Variable angleY4 = new Variable("angleY4");
		Variable angleZ4 = new Variable("angleZ4");
		Variable forceX4 = new Variable("forceX4");
		Variable forceY4 = new Variable("forceY4");
		Variable forceZ4 = new Variable("forceZ4");
		Variable torqueX4 = new Variable("torqueX4");
		Variable torqueY4 = new Variable("torqueY4");
		Variable torqueZ4 = new Variable("torqueZ4");
		pos.Add(5);
		pos.Add(0);
		pos.Add(0);
		angles.Add(0);
		angles.Add(0);
		angles.Add(0);
		mass.Add(1);
		force.Add(0);
		force.Add(-9.8);
		torque.Add(0);
		torque.Add(-9.8);
		torque.Add(0);
		Function[,] A4 = { { 1, 0, 0, posX4 }, { 0, 1, 0, posY4}, { 0, 0, 1, posZ4}, { 0, 0, 0, 1 } };
		A4 = VM.mult(A4, VM.rotX(angleX4, 0, 0, 0));
		A4 = VM.mult(A4, VM.rotY(angleY4, 0, 0, 0));
		A4 = VM.mult(A4, VM.rotZ(angleZ4, 0, 0, 0));
		Function[,] I4 = inertiaMatrixSphere(m4, 0.50);
		Geometries.Sphere sphere4 = new Geometries.Sphere(0.50);
		A4 = VM.mult(A4, VM.rotZ(q4, 0, 0, 0));
		RigidBody rigidBody4 = new RigidBody(A4, new Function[] { q4 }, frictionForce(t, q4), centerOfMass4, I4, m4, "Body4", t);
		rigidBody4.CreateGeometry(device, sphere4, textureMaps[1]);
		rigidBody4.force = new Function[,] { { forceX4}, { forceY4 }, { forceZ4}, { 0 } };
		rigidBody4.orientation = new Variable[] {angleX4, angleY4, angleZ4};
		rigidBody4.position = new Variable[] {posX4, posY4, posZ4};
		rigidBody4.torque = new Function[,] { { torqueX4 }, { torqueY4 }, { torqueZ4 }, { 0 }};
		rigidBody4.geometry = sphere4;
		alljoints.Add(rigidBody4);
		rigidBody3.c(rigidBody4);

		g = new Graph<JointNode>(rigidBody0, alljoints.ToArray());
		RigidBodySystem RBSTemp = new RigidBodySystem(g, t, device, mass.ToArray(), pos.ToArray(), angles.ToArray(), force.ToArray(), torque.ToArray());
		RBSTemp.initialize();
		return RBSTemp;
	} 


        public void populateTreeView (TreeView rigidBodyHierarchy, string RBSFileName)
        {
            TreeNode root = new TreeNode(RBSFileName);
            root.ImageIndex = 0;
            root.Name = RBSFileName;
            rigidBodyHierarchy.Nodes.Insert(0, root);
	cRigidBodyUI body0= new cRigidBodyUI();
		body0.position.X = 0;
		body0.position.Y = 5;
		body0.position.Z = 0;
		body0.orientation.X = 0;
		body0.orientation.Y = 0;
		body0.orientation.Z = 0;
		body0.Sphere.Radius = 0.5;
		body0.Sphere.Use_sphere = true;
		body0.Cylinder.Final_Angle = 360;
		body0.Cylinder.Height = 2;
		body0.Cylinder.Initial_Angle = 0;
		body0.Cylinder.Radius = 0.3;
		body0.Cylinder.Use_Cylinder = false;
		body0.Torus.Inner_Radius = 0.2;
		body0.Torus.Outer_Radius = 0.8;
		body0.Torus.Use_Torus = false;
		body0.Mass = 1;
		body0.Forces.X = 0;
		body0.Forces.Y = -9.8;
		body0.Forces.Z = 0;
		body0.Torque.X = 15;
		body0.Torque.Y = 0;
		body0.Torque.Z = 0;
        body0.RotXAxis = false;
        body0.RotYAxis = false;
        body0.RotZAxis = false;
        body0.TransXaxis = false;
        body0.TransYaxis = false;
        body0.TransZaxis = false;
        body0.Surface = false;
		body0.Name = "rootBody";
		body0.Text = "rootBody";
		body0.ImageIndex = 1;

		cRigidBodyUI body1= new cRigidBodyUI();
		body1.position.X = 0;
		body1.position.Y = 0;
		body1.position.Z = 0;
		body1.orientation.X = 0;
		body1.orientation.Y = 0;
		body1.orientation.Z = 0;
		body1.Sphere.Radius = 0.5;
		body1.Sphere.Use_sphere = false;
		body1.Cylinder.Final_Angle = 360;
		body1.Cylinder.Height = 5;
		body1.Cylinder.Initial_Angle = 0;
		body1.Cylinder.Radius = 0.1;
		body1.Cylinder.Use_Cylinder = true;
		body1.Torus.Inner_Radius = 0.2;
		body1.Torus.Outer_Radius = 0.8;
		body1.Torus.Use_Torus = false;
		body1.Mass = 1;
		body1.Forces.X = 0;
		body1.Forces.Y = -9.8;
		body1.Forces.Z = 0;
		body1.Torque.X = 0;
		body1.Torque.Y = -30;
		body1.Torque.Z = 0;
        body1.RotXAxis = false;
        body1.RotYAxis = false;
        body1.RotZAxis = false;
        body1.TransXaxis = false;
        body1.TransYaxis = false;
        body1.TransZaxis = false;
        body1.Surface = false;
		body1.Name = "Body1";
		body1.Text = "Body1";
		body1.ImageIndex = 1;
		body0.Nodes.Insert(body0.Nodes.Count + 1, body1);

		cRigidBodyUI body2= new cRigidBodyUI();
		body2.position.X = 5;
		body2.position.Y = 0;
		body2.position.Z = 0;
		body2.orientation.X = 0;
		body2.orientation.Y = 0;
		body2.orientation.Z = 0;
		body2.Sphere.Radius = 0.5;
		body2.Sphere.Use_sphere = true;
		body2.Cylinder.Final_Angle = 360;
		body2.Cylinder.Height = 2;
		body2.Cylinder.Initial_Angle = 0;
		body2.Cylinder.Radius = 0.3;
		body2.Cylinder.Use_Cylinder = false;
		body2.Torus.Inner_Radius = 0.2;
		body2.Torus.Outer_Radius = 0.8;
		body2.Torus.Use_Torus = false;
		body2.Mass = 1;
		body2.Forces.X = 0;
		body2.Forces.Y = -9.8;
		body2.Forces.Z = 0;
		body2.Torque.X = -20;
		body2.Torque.Y = 0;
		body2.Torque.Z = 0;
        body2.RotXAxis = false;
        body2.RotYAxis = false;
        body2.RotZAxis = false;
        body2.TransXaxis = false;
        body2.TransYaxis = false;
        body2.TransZaxis = false;
        body2.Surface = false;
		body2.Name = "Body2";
		body2.Text = "Body2";
		body2.ImageIndex = 1;
		body1.Nodes.Insert(body1.Nodes.Count + 1, body2);

		cRigidBodyUI body3= new cRigidBodyUI();
		body3.position.X = 0;
		body3.position.Y = 0;
		body3.position.Z = 0;
		body3.orientation.X = 0;
		body3.orientation.Y = 0;
		body3.orientation.Z = 0;
		body3.Sphere.Radius = 0.5;
		body3.Sphere.Use_sphere = false;
		body3.Cylinder.Final_Angle = 360;
		body3.Cylinder.Height = 5;
		body3.Cylinder.Initial_Angle = 0;
		body3.Cylinder.Radius = 0.1;
		body3.Cylinder.Use_Cylinder = true;
		body3.Torus.Inner_Radius = 0.2;
		body3.Torus.Outer_Radius = 0.8;
		body3.Torus.Use_Torus = false;
		body3.Mass = 1;
		body3.Forces.X = 0;
		body3.Forces.Y = -9.8;
		body3.Forces.Z = 0;
		body3.Torque.X = 0;
		body3.Torque.Y = 30;
		body3.Torque.Z = 0;
        body3.RotXAxis = false;
        body3.RotYAxis = false;
        body3.RotZAxis = false;
        body3.TransXaxis = false;
        body3.TransYaxis = false;
        body3.TransZaxis = false;
        body3.Surface = false;
		body3.Name = "Body3";
		body3.Text = "Body3";
		body3.ImageIndex = 1;
		body0.Nodes.Insert(body0.Nodes.Count + 1, body3);

		cRigidBodyUI body4= new cRigidBodyUI();
		body4.position.X = 5;
		body4.position.Y = 0;
		body4.position.Z = 0;
		body4.orientation.X = 0;
		body4.orientation.Y = 0;
		body4.orientation.Z = 0;
		body4.Sphere.Radius = 0.5;
		body4.Sphere.Use_sphere = true;
		body4.Cylinder.Final_Angle = 360;
		body4.Cylinder.Height = 2;
		body4.Cylinder.Initial_Angle = 0;
		body4.Cylinder.Radius = 0.3;
		body4.Cylinder.Use_Cylinder = false;
		body4.Torus.Inner_Radius = 0.2;
		body4.Torus.Outer_Radius = 0.8;
		body4.Torus.Use_Torus = false;
		body4.Mass = 1;
		body4.Forces.X = 0;
		body4.Forces.Y = -9.8;
		body4.Forces.Z = 0;
		body4.Torque.X = -20;
		body4.Torque.Y = 0;
		body4.Torque.Z = 0;
        body4.RotXAxis = false;
        body4.RotYAxis = false;
        body4.RotZAxis = false;
        body4.TransXaxis = false;
        body4.TransYaxis = false;
        body4.TransZaxis = false;
        body4.Surface = false;
		body4.Name = "Body4";
		body4.Text = "Body4";
		body4.ImageIndex = 1;
		body3.Nodes.Insert(body3.Nodes.Count + 1, body4);

		rigidBodyHierarchy.Nodes[0].Nodes.Insert(rigidBodyHierarchy.Nodes[0].Nodes.Count, body0);
	}

        public Function[] frictionForce(Variable t, params Function[] genCoords)
        {
            Function[] result = new Function[genCoords.Length];

            //for (int i = 0; i < genCoords.Length; i++) { result[i] = (- Math.PI/2.0 - genCoords[i] ) - .2 * Function.D(genCoords[i], t); } //this works only for one cylinder
            for (int i = 0; i < genCoords.Length; i++) { result[i] = -2 * Function.D(genCoords[i], t); }
            return result;
        }

        public Function[,] inertiaMatrixCylinder(double mass, double radius, double height)
        {
            // moment of inertia:
            return new Function[,]{{1/12.0*mass*(3*(radius*radius) + (height*height)), 0 ,0 ,0},
                         {0, .5*mass*(radius*radius), 0 ,0},
                         {0, 0, 1/12.0*mass*(3*(radius*radius) + (height*height)), 0},
                         {0,0,0,0}};
        }

        public Function[,] inertiaMatrixCylinder(Variable mass, double radius, double height)
        {
            // moment of inertia:
            return new Function[,]{{1/12.0*mass*(3*(radius*radius) + (height*height)), 0 ,0 ,0},
                         {0, .5*mass*(radius*radius), 0 ,0},
                         {0, 0, 1/12.0*mass*(3*(radius*radius) + (height*height)), 0},
                         {0,0,0,0}};
        }

        public Function[,] inertiaMatrixTorus(double mass, double largeRadius, double smallRadius)
        {
            return new Function[,]{{1/8.0*mass*(4*largeRadius*largeRadius + 5*smallRadius*smallRadius), 0 ,0 ,0},
                         {0, .25*mass*(4*largeRadius*largeRadius + 3*smallRadius*smallRadius), 0 ,0},
                         {0, 0, 1/8.0*mass*(4*largeRadius*largeRadius + 5*smallRadius*smallRadius), 0},
                         {0,0,0,0}};
        }

        public Function[,] inertiaMatrixTorus(Variable mass, double largeRadius, double smallRadius)
        {
            return new Function[,]{{1/8.0*mass*(4*largeRadius*largeRadius + 5*smallRadius*smallRadius), 0 ,0 ,0},
                         {0, .25*mass*(4*largeRadius*largeRadius + 3*smallRadius*smallRadius), 0 ,0},
                         {0, 0, 1/8.0*mass*(4*largeRadius*largeRadius + 5*smallRadius*smallRadius), 0},
                         {0,0,0,0}};
        }

        public Function[,] inertiaMatrixSphere(double mass, double radius)
        {
            return new Function[,]{ {0.4*mass*radius*radius, 0 ,0 ,0},
                                    {0, 0.4*mass*radius*radius, 0 ,0},
                                    {0, 0, 0.4*mass*radius*radius, 0},
                                    {0,0,0,0}};
        }

        public Function[,] inertiaMatrixSphere(Variable mass, double radius)
        {
            return new Function[,]{ {0.4*mass*radius*radius, 0 ,0 ,0},
                                    {0, 0.4*mass*radius*radius, 0 ,0},
                                    {0, 0, 0.4*mass*radius*radius, 0},
                                    {0,0,0,0}};
        }

    }
}
