﻿
using System;
using System.Diagnostics;
using System.IO;
using System.Windows.Forms;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using matrix;
using utilities;
using DifferentiableFunction;
using Dynamics;


namespace WinFormsGraphicsDevice
{
    //class RigidBodySystem;
    public class rbsExample6 : iRigidBodySystemFunctions
    {
        /*
        public balls ()
        {
        }
	    */
        public RigidBodySystem build(GraphicsDevice device, Texture2D[] textureMaps)
        {
            Function.newContext();
            List<RigidBody> alljoints = new List<RigidBody>();
            Variable t = new Variable("t");
            Graph<JointNode> g = null;
            Function[,] centerOfMass = { { 0 }, { 0 }, { 0 }, { 1 } }; //point so need 1 in 4th position


            List<double> pos = new List<double>();
            List<double> mass = new List<double>();
            List<double> angles = new List<double>();
            List<double> force = new List<double>();
            List<double> torque = new List<double>();
            UnspecifiedFunction q0 = UnspecifiedFunction.functionOf("q0", t);
            Variable m0 = new Variable("m0");
            Variable posX0 = new Variable("posX0");
            Variable posY0 = new Variable("posY0");
            Variable posZ0 = new Variable("posZ0");
            Variable angleX0 = new Variable("angleX0");
            Variable angleY0 = new Variable("angleY0");
            Variable angleZ0 = new Variable("angleZ0");
            Variable forceX0 = new Variable("forceX0");
            Variable forceY0 = new Variable("forceY0");
            Variable forceZ0 = new Variable("forceZ0");
            Variable torqueX0 = new Variable("torqueX0");
            Variable torqueY0 = new Variable("torqueY0");
            Variable torqueZ0 = new Variable("torqueZ0");
            pos.Add(0);
            pos.Add(5);
            pos.Add(0);
            angles.Add(0);
            angles.Add(0);
            angles.Add(0);
            mass.Add(1);
            force.Add(0);
            force.Add(-9.8);
            force.Add(0);
            torque.Add(0);
            torque.Add(0);
            torque.Add(0);
            Function[,] A0 = { { 1, 0, 0, posX0 }, { 0, 1, 0, posY0 }, { 0, 0, 1, posZ0 }, { 0, 0, 0, 1 } };
            Function[,] rb0 = null;
            A0 = VM.mult(A0, VM.rotX(angleX0, 0, 0, 0));
            A0 = VM.mult(A0, VM.rotY(angleY0, 0, 0, 0));
            A0 = VM.mult(A0, VM.rotZ(angleZ0, 0, 0, 0));
            A0 = VM.mult(A0, VM.rotX(q0, 0, 0, 0));
            Function[,] I = inertiaMatrixSphere(m0, 0.50);
            Geometries.Sphere sphere = new Geometries.Sphere(0.5);
            RigidBody rigidBody0 = new RigidBody(A0, new Function[] { q0 }, frictionForce(t, q0), centerOfMass, I, m0, "rootBody", t);
            rigidBody0.CreateGeometry(device, sphere, textureMaps[10 % 4]);
            rigidBody0.geometry = sphere;
            rigidBody0.orientation = new Variable[] { angleX0, angleY0, angleZ0 };
            rigidBody0.position = new Variable[] { posX0, posY0, posZ0 };
            rigidBody0.force = new Function[,] { { forceX0 }, { forceY0 }, { forceZ0 }, { 0 } };
            rigidBody0.torque = new Function[,] { { torqueX0 }, { torqueY0 }, { torqueZ0 }, { 0 } };
            alljoints.Add(rigidBody0);

            Function[,] centerOfMass1 = { { 0 }, { 0 }, { 0 }, { 1 } };
            Function[,] rb1 = null;
            UnspecifiedFunction q1 = UnspecifiedFunction.functionOf("q1", t);
            Variable m1 = new Variable("m1");
            Variable posX1 = new Variable("posX1");
            Variable posY1 = new Variable("posY1");
            Variable posZ1 = new Variable("posZ1");
            Variable angleX1 = new Variable("angleX1");
            Variable angleY1 = new Variable("angleY1");
            Variable angleZ1 = new Variable("angleZ1");
            Variable forceX1 = new Variable("forceX1");
            Variable forceY1 = new Variable("forceY1");
            Variable forceZ1 = new Variable("forceZ1");
            Variable torqueX1 = new Variable("torqueX1");
            Variable torqueY1 = new Variable("torqueY1");
            Variable torqueZ1 = new Variable("torqueZ1");
            pos.Add(1);
            pos.Add(0);
            pos.Add(0);
            angles.Add(0);
            angles.Add(0);
            angles.Add(0);
            mass.Add(1);
            force.Add(0);
            force.Add(-9.8);
            force.Add(0);
            torque.Add(0);
            torque.Add(0);
            torque.Add(0);
            Function[,] A1 = { { 1, 0, 0, posX1 }, { 0, 1, 0, posY1 }, { 0, 0, 1, posZ1 }, { 0, 0, 0, 1 } };
            A1 = VM.mult(A1, VM.rotX(angleX1, 0, 0, 0));
            A1 = VM.mult(A1, VM.rotY(angleY1, 0, 0, 0));
            A1 = VM.mult(A1, VM.rotZ(angleZ1, 0, 0, 0));
            Function[,] I1 = inertiaMatrixSphere(m1, 0.50);
            Geometries.Sphere sphere1 = new Geometries.Sphere(0.50);
            A1 = VM.mult(A1, VM.rotX(q1, 0, 0, 0));
            A1 = VM.mult(A1, VM.rotY(q1, 0, 0, 0));
            A1 = VM.mult(A1, VM.rotZ(q1, 0, 0, 0));
            RigidBody rigidBody1 = new RigidBody(A1, new Function[] { q1 }, frictionForce(t, q1), centerOfMass1, I1, m1, "Body1", t);
            rigidBody1.CreateGeometry(device, sphere1, textureMaps[1]);
            rigidBody1.force = new Function[,] { { forceX1 }, { forceY1 }, { forceZ1 }, { 0 } };
            rigidBody1.orientation = new Variable[] { angleX1, angleY1, angleZ1 };
            rigidBody1.position = new Variable[] { posX1, posY1, posZ1 };
            rigidBody1.torque = new Function[,] { { torqueX1 }, { torqueY1 }, { torqueZ1 }, { 0 } };
            rigidBody1.geometry = sphere1;
            alljoints.Add(rigidBody1);
            rigidBody0.c(rigidBody1);

            g = new Graph<JointNode>(rigidBody0, alljoints.ToArray());
            RigidBodySystem RBSTemp = new RigidBodySystem(g, t, device, mass.ToArray(), pos.ToArray(), angles.ToArray(), force.ToArray(), torque.ToArray());
            RBSTemp.initialize();
            return RBSTemp;
        }


        public void populateTreeView(TreeView rigidBodyHierarchy, string RBSFileName)
        {
            TreeNode root = new TreeNode(RBSFileName);
            root.ImageIndex = 0;
            root.Name = RBSFileName;
            rigidBodyHierarchy.Nodes.Insert(0, root);
            cRigidBodyUI body0 = new cRigidBodyUI();
            body0.position.X = 0;
            body0.position.Y = 5;
            body0.position.Z = 0;
            body0.orientation.X = 0;
            body0.orientation.Y = 0;
            body0.orientation.Z = 0;
            body0.Sphere.Radius = 0.5;
            body0.Sphere.Use_sphere = true;
            body0.Cylinder.Final_Angle = 360;
            body0.Cylinder.Height = 2;
            body0.Cylinder.Initial_Angle = 0;
            body0.Cylinder.Radius = 0.3;
            body0.Cylinder.Use_Cylinder = false;
            body0.Torus.Inner_Radius = 0.2;
            body0.Torus.Outer_Radius = 0.8;
            body0.Torus.Use_Torus = false;
            body0.Mass = 1;
            body0.Forces.X = 0;
            body0.Forces.Y = -9.8;
            body0.Forces.Z = 0;
            body0.Torque.X = 0;
            body0.Torque.Y = 0;
            body0.Torque.Z = 0;
            body0.RotXAxis = false;
            body0.RotYAxis = false;
            body0.RotZAxis = false;
            body0.TransXaxis = false;
            body0.TransYaxis = false;
            body0.TransZaxis = false; 
            body0.Surface = false;
            body0.Name = "rootBody";
            body0.Text = "rootBody";
            body0.ImageIndex = 1;

            cRigidBodyUI body1 = new cRigidBodyUI();
            body1.position.X = 1;
            body1.position.Y = 0;
            body1.position.Z = 0;
            body1.orientation.X = 0;
            body1.orientation.Y = 0;
            body1.orientation.Z = 0;
            body1.Sphere.Radius = 0.5;
            body1.Sphere.Use_sphere = true;
            body1.Cylinder.Final_Angle = 360;
            body1.Cylinder.Height = 2;
            body1.Cylinder.Initial_Angle = 0;
            body1.Cylinder.Radius = 0.3;
            body1.Cylinder.Use_Cylinder = false;
            body1.Torus.Inner_Radius = 0.2;
            body1.Torus.Outer_Radius = 0.8;
            body1.Torus.Use_Torus = false;
            body1.Mass = 1;
            body1.Forces.X = 0;
            body1.Forces.Y = -9.8;
            body1.Forces.Z = 0;
            body1.Torque.X = 5;
            body1.Torque.Y = 5;
            body1.Torque.Z = 5;
            body1.RotXAxis = false;
            body1.RotYAxis = false;
            body1.RotZAxis = false;
            body1.TransXaxis = false;
            body1.TransYaxis = false;
            body1.TransZaxis = false; 
            body1.Surface = false;
            body1.Name = "Body1";
            body1.Text = "Body1";
            body1.ImageIndex = 1;
            body0.Nodes.Insert(body0.Nodes.Count + 1, body1);

            rigidBodyHierarchy.Nodes[0].Nodes.Insert(rigidBodyHierarchy.Nodes[0].Nodes.Count, body0);
        }

        public Function[] frictionForce(Variable t, params Function[] genCoords)
        {
            Function[] result = new Function[genCoords.Length];

            //for (int i = 0; i < genCoords.Length; i++) { result[i] = (- Math.PI/2.0 - genCoords[i] ) - .2 * Function.D(genCoords[i], t); } //this works only for one cylinder
            for (int i = 0; i < genCoords.Length; i++) { result[i] = -2 * Function.D(genCoords[i], t); }
            return result;
        }

        public Function[,] inertiaMatrixCylinder(double mass, double radius, double height)
        {
            // moment of inertia:
            return new Function[,]{{1/12.0*mass*(3*(radius*radius) + (height*height)), 0 ,0 ,0},
                         {0, .5*mass*(radius*radius), 0 ,0},
                         {0, 0, 1/12.0*mass*(3*(radius*radius) + (height*height)), 0},
                         {0,0,0,0}};
        }

        public Function[,] inertiaMatrixCylinder(Variable mass, double radius, double height)
        {
            // moment of inertia:
            return new Function[,]{{1/12.0*mass*(3*(radius*radius) + (height*height)), 0 ,0 ,0},
                         {0, .5*mass*(radius*radius), 0 ,0},
                         {0, 0, 1/12.0*mass*(3*(radius*radius) + (height*height)), 0},
                         {0,0,0,0}};
        }

        public Function[,] inertiaMatrixTorus(double mass, double largeRadius, double smallRadius)
        {
            return new Function[,]{{1/8.0*mass*(4*largeRadius*largeRadius + 5*smallRadius*smallRadius), 0 ,0 ,0},
                         {0, .25*mass*(4*largeRadius*largeRadius + 3*smallRadius*smallRadius), 0 ,0},
                         {0, 0, 1/8.0*mass*(4*largeRadius*largeRadius + 5*smallRadius*smallRadius), 0},
                         {0,0,0,0}};
        }

        public Function[,] inertiaMatrixTorus(Variable mass, double largeRadius, double smallRadius)
        {
            return new Function[,]{{1/8.0*mass*(4*largeRadius*largeRadius + 5*smallRadius*smallRadius), 0 ,0 ,0},
                         {0, .25*mass*(4*largeRadius*largeRadius + 3*smallRadius*smallRadius), 0 ,0},
                         {0, 0, 1/8.0*mass*(4*largeRadius*largeRadius + 5*smallRadius*smallRadius), 0},
                         {0,0,0,0}};
        }

        public Function[,] inertiaMatrixSphere(double mass, double radius)
        {
            return new Function[,]{ {0.4*mass*radius*radius, 0 ,0 ,0},
                                    {0, 0.4*mass*radius*radius, 0 ,0},
                                    {0, 0, 0.4*mass*radius*radius, 0},
                                    {0,0,0,0}};
        }

        public Function[,] inertiaMatrixSphere(Variable mass, double radius)
        {
            return new Function[,]{ {0.4*mass*radius*radius, 0 ,0 ,0},
                                    {0, 0.4*mass*radius*radius, 0 ,0},
                                    {0, 0, 0.4*mass*radius*radius, 0},
                                    {0,0,0,0}};
        }

    }
}
